#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.0
 Author:         myName

 Script Function:
	Template AutoIt script.

#ce ----------------------------------------------------------------------------

; Script Start - Add your code below here

Func _New_RSObj($Obj)
	Local $oRS = _AutoItObject_Create()
	_AutoItObject_AddProperty($oRS, "IniObject")

	_AutoItObject_AddMethod($oRS, "GetNameByUrl", "_RSObjGetNameByUrl")
	_AutoItObject_AddMethod($oRS, "GetUrlByName", "_RSObjGetUrlByName")
	_AutoItObject_AddMethod($oRS, "GetRSs", "_RSObjGetRSs")
	_AutoItObject_AddMethod($oRS, "GetAll", "_RSObjGetAll")

	$oRS.IniObject = $Obj

	Return $oRS
EndFunc   ;==>LinkedList

Func _RSObjGetAll($oSelf)
	If Not IsObj($oSelf.IniObject) Then Return 0

	Local $Index = $oSelf.IniObject.ReadSection("index")
	Local $Array[UBound($Index)][4]
	Local $Split, $Trim

	For $i = 0 To UBound($Index) -1
		$Split = StringSplit($Index[$i][1], ",", 2)
		$Trim = StringTrimLeft($Split[0], 9)

		$Array[$i][0] = $oSelf.IniObject.Read("Sendername", "Sender" & $Trim)
		$Array[$i][1] = $oSelf.IniObject.Read("Genre", "Genre" & $Trim)
		$Array[$i][2] = $oSelf.IniObject.Read("Bewertung", "Bewertung" & $Trim)
		$Array[$i][3] = $oSelf.IniObject.Read("Senderurl", "Senderurl" & $Trim)
	Next

	Return $Array
EndFunc

Func _RSObjGetRSs($oSelf)
	If Not IsObj($oSelf.IniObject) Then Return 0
	Local $RSs = $oSelf.IniObject.ReadSection("Sendername")
	Local $Bound = UBound($RSs)
	Local $Array[$Bound]

	For $i = 0 To $Bound -1
		$Array[$i] = $RSs[$i][1]
	Next

	Return $Array
EndFunc

Func _RSObjGetUrlByName($oSelf, $Name)
	If Not IsObj($oSelf.IniObject) Then Return 0
	Local $Array = $oSelf.IniObject.Array
	Local $Number, $Url

	For $i = 0 To UBound($Array) -1
		Switch $Array[$i][2]
			Case $Name
				$Number = StringTrimLeft($Array[$i][1], 6)
		EndSwitch
	Next

	Return $oSelf.IniObject.Read("Senderurl", "Senderurl" & $Number)
EndFunc

Func _RSObjGetNameByUrl($oSelf, $Url)
	If Not IsObj($oSelf.IniObject) Then Return 0
	Local $Array = $oSelf.IniObject.Array
	Local $Number, $Name
	For $i = 0 To UBound($Array) -1
		Switch $Array[$i][2]
			Case $Url
				$Number = StringTrimLeft($Array[$i][1], 9)
		EndSwitch
	Next
	For $i = 0 To UBound($Array) -1
		If $Array[$i][0] = "Sendername" And StringTrimLeft($Array[$i][1], 6) = $Number Then
			$Name = $Array[$i][2]
		EndIf
	Next
	If $Name = "" Then Return 0
	Return $Name
EndFunc




