#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         myName

 Script Function:
	Template AutoIt script.

#ce ----------------------------------------------------------------------------

; Script Start - Add your code below here

#include <AutoItObject.au3>
#include <GuiToolBar.au3>
#include <GuiImageList.au3>

_AutoItObject_Startup()


Func _New_RSMGUI()
	Local $oRSMGUI = _AutoItObject_Create()
	_AutoItObject_AddProperty($oRSMGUI, "handle")
	_AutoItObject_AddProperty($oRSMGUI, "menu")
	_AutoItObject_AddProperty($oRSMGUI, "toolbar")
	_AutoItObject_AddProperty($oRSMGUI, "listview")

	_AutoItObject_AddMethod($oRSMGUI, "create", "_rsmGuiCreate")
	_AutoItObject_AddMethod($oRSMGUI, "show", "_rsmGuiShow")
	_AutoItObject_AddMethod($oRSMGUI, "loadsettings", "_rsmGuiloadsettings")
	_AutoItObject_AddMethod($oRSMGUI, "GUISetOnEvent", "_rsmGuiGUISetOnEvent")
	_AutoItObject_AddMethod($oRSMGUI, "GUICtrlSetOnEven", "_rsmGuiGUICtrlSetOnEvent")

	#region Menu
	Local $oRSMGUIMenu = _AutoItObject_Create()

	_AutoItObject_AddProperty($oRSMGUIMenu, "item")

	_AutoItObject_AddProperty($oRSMGUIMenu, "file")
	_AutoItObject_AddProperty($oRSMGUIMenu, "edit")
	_AutoItObject_AddProperty($oRSMGUIMenu, "extras")
	_AutoItObject_AddProperty($oRSMGUIMenu, "info")


	Local $oRSMGUIMenuItem = _AutoItObject_Create()
	_AutoItObject_AddProperty($oRSMGUIMenuItem, "exit")
	_AutoItObject_AddProperty($oRSMGUIMenuItem, "add")
	_AutoItObject_AddProperty($oRSMGUIMenuItem, "edit")
	_AutoItObject_AddProperty($oRSMGUIMenuItem, "delete")
	_AutoItObject_AddProperty($oRSMGUIMenuItem, "feedback")
	_AutoItObject_AddProperty($oRSMGUIMenuItem, "about")
	_AutoItObject_AddProperty($oRSMGUIMenuItem, "version")


	$oRSMGUIMenu.item = $oRSMGUIMenuItem
	$oRSMGUI.menu = $oRSMGUIMenu
	#endregion Menu


	#region ToolBar
	Local $oRSMGUIToolBar = _AutoItObject_Create()
	_AutoItObject_AddProperty($oRSMGUIToolBar, "handle")


	$oRSMGUI.toolbar = $oRSMGUIToolBar
	#endregion ToolBar






	Return $oRSMGUI
EndFunc   ;==>LinkedList

Func _rsmGuiloadsettings($oSelf, $Obj1) ;DataObj
	Local $rsObj = _New_RSObj($Obj1)
	Local $Array = $rsObj.GetAll()

	For $i = 0 To UBound($Array) -1
		GUICtrlCreateListViewItem($Array[$i][0] & "|" & $Array[$i][1] & "|" & $Array[$i][2] & "|" & $Array[$i][3], $oSelf.listview)
	Next

	_GUICtrlListView_SetColumnWidth($oSelf.listview, 0, 200)
	_GUICtrlListView_SetColumnWidth($oSelf.listview, 1, 110)
	_GUICtrlListView_SetColumnWidth($oSelf.listview, 2, 80)
	_GUICtrlListView_SetColumnWidth($oSelf.listview, 3, 300)




EndFunc

Func _rsmGuiCreate($oSelf)
	$oSelf.handle = Number(GUICreate("Desktop Radio - Radio Station Manager", 715, 470))

	GUISetIcon(@ScriptDir)

	$oSelf.menu.file = GUICtrlCreateMenu("Datei")
	$oSelf.menu.item.exit = GUICtrlCreateMenuItem("Beenden", $oSelf.menu.file)
	$oSelf.menu.edit = GUICtrlCreateMenu("Bearbeiten")
	$oSelf.menu.item.add = GUICtrlCreateMenuItem("Hinzufgen", $oSelf.menu.edit)
	$oSelf.menu.item.edit = GUICtrlCreateMenuItem("Bearbeiten", $oSelf.menu.edit)
	$oSelf.menu.item.delete = GUICtrlCreateMenuItem("Lschen", $oSelf.menu.edit)
	$oSelf.menu.extras = GUICtrlCreateMenu("Extras")
	$oSelf.menu.item.feedback = GUICtrlCreateMenuItem("Feedback", $oSelf.menu.extras)
	$oSelf.menu.info = GUICtrlCreateMenu("Info")
	$oSelf.menu.item.about = GUICtrlCreateMenuItem("ber Radio Station Manager", $oSelf.menu.info)
	$oSelf.menu.item.version = GUICtrlCreateMenuItem("Versionshinweise", $oSelf.menu.info)

	$oSelf.toolbar.handle = Number(_GUICtrlToolbar_Create(HWnd($oSelf.handle)))

	Local $Dir = @ScriptDir & "\images\Icons\Toolbar"
	Local $ImgList = _GUIImageList_Create(32, 32, 5)
	Local $Thwnd = HWnd($oSelf.toolbar.handle)
	_GUIImageList_AddIconSize($ImgList, $Dir & "\Previous.ico")
	_GUIImageList_AddIconSize($ImgList, $Dir & "\Next.ico")

	_GUIImageList_AddIconSize($ImgList, $Dir & "\Add.ico")
	_GUIImageList_AddIconSize($ImgList, $Dir & "\Edit.ico")
	_GUIImageList_AddIconSize($ImgList, $Dir & "\Delete.ico")

	_GUIImageList_AddIconSize($ImgList, $Dir & "\Stop.ico")
	_GUIImageList_AddIconSize($ImgList, $Dir & "\Play.ico")
	_GUIImageList_AddIconSize($ImgList, $Dir & "\Pause.ico")

	_GUIImageList_AddIconSize($ImgList, $Dir & "\Refresh.ico")
	_GUIImageList_AddIconSize($ImgList, $Dir & "\Help.ico")
	_GUIImageList_AddIconSize($ImgList, $Dir & "\Mail.ico")

	_GUICtrlToolbar_SetImageList($Thwnd, $ImgList)


	_GUICtrlToolbar_AddButton($Thwnd, 1000, 0)
	_GUICtrlToolbar_AddButton($Thwnd, 1000, 1)
	_GUICtrlToolbar_AddButtonSep($Thwnd)
	_GUICtrlToolbar_AddButton($Thwnd, 1000, 2)
	_GUICtrlToolbar_AddButton($Thwnd, 1000, 3)
	_GUICtrlToolbar_AddButton($Thwnd, 1000, 4)
	_GUICtrlToolbar_AddButtonSep($Thwnd)
	_GUICtrlToolbar_AddButton($Thwnd, 1000, 5)
	_GUICtrlToolbar_AddButton($Thwnd, 1000, 6)
	_GUICtrlToolbar_AddButton($Thwnd, 1000, 7)
	_GUICtrlToolbar_AddButtonSep($Thwnd)
	_GUICtrlToolbar_AddButton($Thwnd, 1000, 8)
	_GUICtrlToolbar_AddButton($Thwnd, 1000, 9)
	_GUICtrlToolbar_AddButton($Thwnd, 1000, 10)






	Local $sParts[3] = [75, 150, -1]
	Local $sHwnd = _GUICtrlStatusBar_Create(HWnd($oSelf.handle), $sParts)



	Local $Tsize = ControlGetPos("", "", $Thwnd)
	Local $Ssize = ControlGetPos("", "", $sHwnd)
	Local $Wsize = WinGetClientSize(HWnd($oSelf.handle))

	$oSelf.listview = GUICtrlCreateListView("Sendername|Genre|Bewertung|Adresse", 0, $Tsize[3], $Wsize[0], $Wsize[1] - $Tsize[3] - $Ssize[3])


EndFunc

Func _rsmGuiShow($oSelf, $Show)
	Switch $Show
		Case True
			GUISetState(@SW_SHOW, HWnd($oSelf.handle))
		Case False
			GUISetState(@SW_HIDE, HWnd($oSelf.handle))
	EndSwitch
EndFunc

Func _rsmGuiGUISetOnEvent($oSelf, $event, $function)
	GUISetOnEvent($event, $function, HWnd($oSelf.handle))
EndFunc

Func _rsmGuiGUICtrlSetOnEvent($oSelf, $CtrlID, $function)
	GUICtrlSetOnEvent($CtrlID, $function)
EndFunc


















