#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         myName

 Script Function:
	Template AutoIt script.

#ce ----------------------------------------------------------------------------

; Script Start - Add your code below here

Func GuiRoundCorners($h_win, $i_x1, $i_y1, $i_x3, $i_y3)
	$pos = WinGetPos($h_win)
	$ret = DllCall("gdi32.dll", "long", "CreateRoundRectRgn", "long", $i_x1, "long", $i_y1, "long", $pos[2], "long", $pos[3], "long", $i_x3, "long", $i_y3)
	If $ret[0] Then
		$ret2 = DllCall("user32.dll", "long", "SetWindowRgn", "hwnd", $h_win, "long", $ret[0], "int", 1)
		If $ret2[0] Then
			Return 1
		Else
			Return 0
		EndIf
	Else
		Return 0
	EndIf
EndFunc   ;==>GuiRoundCorners

; #FUNCTION# ====================================================================================================================
; Name...........: _WinSetShadow
; Description ...: Sets the Dropshadow for a window
; Syntax.........: _WinSetShadow($hWnd, $sText='', $fShadow=True)
; Parameters ....: $hWnd    - Handle or title of window
;                  $sText   - [optional] Text of window
;                  $fShadow - [optional] Enable or disable shadow (default: True)
; Return values .: Success - 1
;                  Failure - 0, sets @error to:
;                  |1 - no window or OS version too low
;                  |2 - error on fetching ClassLong
;                  |3 - error on setting ClassLong
;                  |4 - other error
; Author ........: ProgAndy
; Modified.......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......:
; ===============================================================================================================================
Func _WinSetShadow($hWnd, $sText='', $fShadow=True)
    ; Author: ProgAndy
    $hWnd = WinGetHandle($hWnd, $sText)
    If Not IsHWnd($hWnd) Or @OSBuild < 2600 Then Return SetError(1,0,0)
    Local $res = DllCall("User32.dll", "ULONG", "GetClassLong", "hwnd", $hWnd, "int", -26)
    If @error Then Return SetError(2,@error,0)
    Local $style = BitOR($res[0], 0x00020000)
    If Not $fShadow Then $style = BitAND($style, BitNOT(0x00020000))
    $res = DllCall("user32.dll", "ulong", "SetClassLong", "hwnd", $hWnd, "int", -26, "long", $style)
    If @error Then Return SetError(3,@error,0)
;~     If $res[0] Then _SendMessage($hWnd, 0x48004000+51, 0, 0)
    If $res[0] Then
        If BitAND(WinGetState($hWnd), 2)=2 Then
            WinSetState($hWnd, "", @SW_HIDE)
            WinSetState($hWnd, "", @SW_SHOW)
        EndIf
        Return 1
    EndIf
    Return SetError(4,0,0)
EndFunc